include machine.e
include wildcard.e
 
global function dskspace(integer drive_num)
-- returns the number of available bytes on a disk, 0 if drive not recognized
-- drive_num 0 is the default, 1 is a, etc...
sequence reg_list
    reg_list = repeat(0, 10)
    reg_list[REG_AX] = #3600        -- call DOS function 36H
    reg_list[REG_DX] = drive_num
    reg_list = dos_interrupt(#21, reg_list)
    -- BX: available clusters; CX: bytes per cluster; AX: sectors per cluster
    -- Note: DX * CX * AX gives the total number of bytes on the disk
    return reg_list[REG_BX] * reg_list[REG_CX] * reg_list[REG_AX]
end function    -- dskspace
 

